import { ColumnOrderState } from '@tanstack/react-table';
import { MaterialReactTableProps, MRT_Column, MRT_ColumnDef, MRT_DefinedColumnDef, MRT_FilterOption } from '.';
export declare const getAllLeafColumnDefs: <D extends Record<string, any> = {}>(columns: MRT_ColumnDef<D>[]) => MRT_ColumnDef<D>[];
export declare const prepareColumns: <D extends Record<string, any> = {}>(columnDefs: MRT_ColumnDef<D>[], currentFilterFns: {
    [key: string]: "between" | "contains" | "empty" | "endsWith" | "equals" | "fuzzy" | "greaterThan" | "lessThan" | "notEmpty" | "notEquals" | "startsWith" | "includesString" | "includesStringSensitive" | "equalsString" | "arrIncludes" | "arrIncludesAll" | "arrIncludesSome" | "weakEquals" | "inNumberRange";
}) => MRT_DefinedColumnDef<D>[];
export declare const reorderColumn: <D extends Record<string, any> = {}>(movingColumn: MRT_Column<D>, receivingColumn: MRT_Column<D>, columnOrder: ColumnOrderState) => ColumnOrderState;
export declare const getLeadingDisplayColumnIds: <D extends Record<string, any> = {}>(props: MaterialReactTableProps<D>) => string[];
export declare const getTrailingDisplayColumnIds: <D extends Record<string, any> = {}>(props: MaterialReactTableProps<D>) => (string | false | undefined)[];
export declare const getDefaultColumnOrderIds: <D extends Record<string, any> = {}>(props: MaterialReactTableProps<D>) => string[];
